#define F_CPU 16000000UL
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <avr/pgmspace.h>
#include <stdio.h>
#include "adc.h"

int main(){
	// setam toti pinii portului A ca pini de iesire
	DDRA=0xff;
	DDRA&=~(1<<PA0);
	DDRD = 0x00;
	DDRD|=(1<<PD7);
	//canalul de intrare pentru microfon
	volatile uint8_t channel=PA0;
	int val,ok=0;
	InitADC(); //initialise the adc
	while(1)
	if((PIND & 0x40)!=0) //cat timp nu e apasat butonul
	{
		ok=0;
		PORTD =0x40;
		PORTA &= 0b00000001;
		_delay_ms(500);
	}
	else
	{
 		if(ok) //daca s-a pornit alarma, aprind-sting ledul
 		{
			PORTD ^= 0b10000000;
			_delay_ms(100);	
		}
		//sting ledurile de pe circuitul de iesire inainte de citire
		PORTA &= 0b00000001;
 		//citesc de pe PA0
		val=ADC_get(channel);
		
		if(val>=625 && val <650)
				{
				PORTA |= 0b00000101;
				//_delay_ms(50);
				}
		if(val>=650 && val<660)
				{
				PORTA |= 0b00001101;
				//_delay_ms(50);
				}
		else if(val>=660 && val<670)
				{
				PORTA |= 0b00011101;
				//_delay_ms(50);
				}
		else if(val>=670 && val<700)
				{
				PORTA |= 0b00111101;
				//_delay_ms(50);
				}
		else if(val>=700)
				{
				PORTA |= 0b01111101;
				//_delay_ms(50);
				if(val > 840) ok=1; //daca a depasit valoarea maxima, se declanseaza alarma
				}
		
		
		_delay_ms(10);
		
	}
	return 0;
}
